#ifndef __KYLIN_AI_IMAGE_RESULT_H__
#define __KYLIN_AI_IMAGE_RESULT_H__

#include <stdint.h>

#include "imageconfig.h"
#include "imageformat.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _VisionImageResult VisionImageResult;

ImageFormat image_result_get_format(VisionImageResult *image_result);
ImageSize image_result_get_size(VisionImageResult *image_result);
int image_result_get_total(VisionImageResult *image_result);
int image_result_get_index(VisionImageResult *image_result);
const uint8_t *image_result_get_data(VisionImageResult *image_result,
                                     int *data_length);
int image_result_get_error_code(VisionImageResult *image_result);
const char *image_result_get_error_message(VisionImageResult *image_result);

typedef void (*VisionImageResultCallback)(VisionImageResult *result,
                                          void *user_data);

#ifdef __cplusplus
}
#endif

#endif
